/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.data;
import android.database.Cursor;
import android.text.TextUtils;
import android.util.Log;
import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.DataColumns;
import net.micode.notes.data.Notes.DataConstants;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.gtask.exception.ActionFailureException;
import net.micode.notes.tool.GTaskStringUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
public class Task extends Node {
    // 定义一个常量，用于标识Task类的简单名称
    private static final String TAG = Task.class.getSimpleName();
    // 定义一个布尔类型的变量，用于标识任务是否完成
    private boolean mCompleted;
    // 定义一个字符串类型的变量，用于存储任务的备注信息
    private String mNotes;
    // 定义一个JSONObject类型的变量，用于存储任务的元信息
    private JSONObject mMetaInfo;
    // 定义一个Task类型的变量，用于存储任务的前一个兄弟任务
    private Task mPriorSibling;
    // 定义一个TaskList类型的变量，用于存储任务的父任务列表
    private TaskList mParent;
// 构造函数，初始化Task对象
    public Task() {
        // 调用父类的构造函数
        super();
        // 初始化mCompleted为false
        mCompleted = false;
        // 初始化mNotes为null
        mNotes = null;
        // 初始化mPriorSibling为null
        mPriorSibling = null;
        // 初始化mParent为null
        mParent = null;
        // 初始化mMetaInfo为null
        mMetaInfo = null;
    }

// 根据actionId获取创建动作
    public JSONObject getCreateAction(int actionId) {
        // 创建一个JSONObject对象
        JSONObject js = new JSONObject();

        try {   
            // 将actionType设置为创建
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE,
                    GTaskStringUtils.GTASK_JSON_ACTION_TYPE_CREATE);

           
            // 将actionId设置为传入的actionId
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId);

            
            // 将index设置为父任务的子任务索引
            js.put(GTaskStringUtils.GTASK_JSON_INDEX, mParent.getChildTaskIndex(this));

            
            // 创建一个JSONObject对象
            JSONObject entity = new JSONObject();
            // 将name设置为当前任务的名称
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName());
            // 将creatorId设置为null
            entity.put(GTaskStringUtils.GTASK_JSON_CREATOR_ID, "null");
            // 将entityType设置为任务
            entity.put(GTaskStringUtils.GTASK_JSON_ENTITY_TYPE,
                    GTaskStringUtils.GTASK_JSON_TYPE_TASK);
 // 如果getNotes()不为空，则将getNotes()的值放入entity中
            if (getNotes() != null) {
                entity.put(GTaskStringUtils.GTASK_JSON_NOTES, getNotes());
            }
 // 将entity放入js中
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity);

            
 // 将mParent的Gid放入js中
            js.put(GTaskStringUtils.GTASK_JSON_PARENT_ID, mParent.getGid());

           
 // 将GTaskStringUtils.GTASK_JSON_TYPE_GROUP放入js中
            js.put(GTaskStringUtils.GTASK_JSON_DEST_PARENT_TYPE,
                    GTaskStringUtils.GTASK_JSON_TYPE_GROUP);

            
 // 将mParent的Gid放入js中
            js.put(GTaskStringUtils.GTASK_JSON_LIST_ID, mParent.getGid());

            
 // 如果mPriorSibling不为空，则将mPriorSibling的Gid放入js中
 // 如果mPriorSibling不为空，则将mPriorSibling的Gid放入js中
            if (mPriorSibling != null) {
                js.put(GTaskStringUtils.GTASK_JSON_PRIOR_SIBLING_ID, mPriorSibling.getGid());
            }

        // 捕获JSONException异常
        } catch (JSONException e) {
            // 打印异常信息
            Log.e(TAG, e.toString());
            // 打印异常堆栈信息
            e.printStackTrace();
            // 抛出ActionFailureException异常
            throw new ActionFailureException("fail to generate task-create jsonobject");
        }

        return js;
    }

    public JSONObject getUpdateAction(int actionId) {
        // 创建一个JSONObject对象
        JSONObject js = new JSONObject();

        try {
           
            // 将action类型设置为更新
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE,
                    GTaskStringUtils.GTASK_JSON_ACTION_TYPE_UPDATE);

            
            // 将actionId放入js中
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId);

           
            // 将getGid()的返回值放入js中
            js.put(GTaskStringUtils.GTASK_JSON_ID, getGid());

            
 // 创建一个JSONObject对象
            JSONObject entity = new JSONObject();
 // 将getName()方法的返回值放入JSONObject对象中，键为GTASK_JSON_NAME
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName());
 // 如果getNotes()方法返回值不为null，则将getNotes()方法的返回值放入JSONObject对象中，键为GTASK_JSON_NOTES
            if (getNotes() != null) {
                entity.put(GTaskStringUtils.GTASK_JSON_NOTES, getNotes());
            }
 // 将getDeleted()方法的返回值放入JSONObject对象中，键为GTASK_JSON_DELETED
            entity.put(GTaskStringUtils.GTASK_JSON_DELETED, getDeleted());
 // 将JSONObject对象放入js对象中，键为GTASK_JSON_ENTITY_DELTA
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity);

        } catch (JSONException e) {
            // 捕获JSON异常
            Log.e(TAG, e.toString());
            // 打印异常信息
            e.printStackTrace();
            // 抛出自定义异常
            throw new ActionFailureException("fail to generate task-update jsonobject");
        }

        return js;
    }

    // 根据远程JSON设置内容
    public void setContentByRemoteJSON(JSONObject js) {
        if (js != null) {
            try {
               
                if (js.has(GTaskStringUtils.GTASK_JSON_ID)) {
                    // 如果json对象中有GTaskStringUtils.GTASK_JSON_ID字段，则设置Gid
                    setGid(js.getString(GTaskStringUtils.GTASK_JSON_ID));
                }

                
                if (js.has(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED)) {
                    // 如果json对象中有GTaskStringUtils.GTASK_JSON_LAST_MODIFIED字段，则设置LastModified
                    setLastModified(js.getLong(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED));
                }

              
                if (js.has(GTaskStringUtils.GTASK_JSON_NAME)) {
                    // 如果json对象中有GTaskStringUtils.GTASK_JSON_NAME字段，则设置Name
                    setName(js.getString(GTaskStringUtils.GTASK_JSON_NAME));
                }

               
                if (js.has(GTaskStringUtils.GTASK_JSON_NOTES)) {
                    // 如果json对象中有GTaskStringUtils.GTASK_JSON_NOTES字段，则设置Notes
                    setNotes(js.getString(GTaskStringUtils.GTASK_JSON_NOTES));
                }

                
                if (js.has(GTaskStringUtils.GTASK_JSON_DELETED)) {
                    // 如果json对象中有GTaskStringUtils.GTASK_JSON_DELETED字段，则设置Deleted
                    setDeleted(js.getBoolean(GTaskStringUtils.GTASK_JSON_DELETED));
                }

               
                if (js.has(GTaskStringUtils.GTASK_JSON_COMPLETED)) {
                    // 如果json对象中有GTaskStringUtils.GTASK_JSON_COMPLETED字段，则设置Completed
                    setCompleted(js.getBoolean(GTaskStringUtils.GTASK_JSON_COMPLETED));
                }
            } catch (JSONException e) {
                // 捕获JSONException异常
                Log.e(TAG, e.toString());
                // 打印异常信息
                e.printStackTrace();
                // 抛出自定义异常ActionFailureException
                throw new ActionFailureException("fail to get task content from jsonobject");
            }
        }
    }

    public void setContentByLocalJSON(JSONObject js) {
        // 判断传入的JSONObject是否为空，或者是否包含META_HEAD_NOTE和META_HEAD_DATA字段
        if (js == null || !js.has(GTaskStringUtils.META_HEAD_NOTE)
                || !js.has(GTaskStringUtils.META_HEAD_DATA)) {
            // 如果不包含，则输出警告日志
            Log.w(TAG, "setContentByLocalJSON: nothing is avaiable");
        }

        try {
            // 获取JSON对象中的note
            JSONObject note = js.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);
            // 获取JSON对象中的dataArray
            JSONArray dataArray = js.getJSONArray(GTaskStringUtils.META_HEAD_DATA);

            // 如果note的类型不是Notes.TYPE_NOTE，则输出错误信息并返回
            if (note.getInt(NoteColumns.TYPE) != Notes.TYPE_NOTE) {
                Log.e(TAG, "invalid type");
                return;
            }

// 遍历dataArray数组
            for (int i = 0; i < dataArray.length(); i++) {
    // 获取数组中的JSONObject对象
                JSONObject data = dataArray.getJSONObject(i);
    // 判断MIME_TYPE是否为NOTE
                if (TextUtils.equals(data.getString(DataColumns.MIME_TYPE), DataConstants.NOTE)) {
        // 设置名称
                    setName(data.getString(DataColumns.CONTENT));
        // 跳出循环
                    break;
                }
            }

// 捕获JSONException异常
        } catch (JSONException e) {
    // 打印异常信息
            Log.e(TAG, e.toString());
    // 打印异常堆栈信息
            e.printStackTrace();
        }
    }

    public JSONObject getLocalJSONFromContent() {
        // 获取笔记名称
        String name = getName();
        try {
            // 如果mMetaInfo为空，说明是新建的笔记
            if (mMetaInfo == null) {
               
                // 如果name为空，说明笔记为空
                if (name == null) {
                    Log.w(TAG, "the note seems to be an empty one");
                    return null;
                }

                JSONObject js = new JSONObject();
                // 创建一个JSONObject对象
                JSONObject note = new JSONObject();
                // 创建一个JSONObject对象
                JSONArray dataArray = new JSONArray();
                // 创建一个JSONArray对象
                JSONObject data = new JSONObject();
                // 创建一个JSONObject对象
                data.put(DataColumns.CONTENT, name);
                // 将name放入data对象中
                dataArray.put(data);
                // 将data对象放入dataArray中
                js.put(GTaskStringUtils.META_HEAD_DATA, dataArray);
                // 将dataArray对象放入js对象中
                note.put(NoteColumns.TYPE, Notes.TYPE_NOTE);
                // 将Notes.TYPE_NOTE放入note对象中
                js.put(GTaskStringUtils.META_HEAD_NOTE, note);
                // 将note对象放入js对象中
                return js;
            } else {
                
                // 获取元信息中的笔记对象
                JSONObject note = mMetaInfo.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);
                // 获取元信息中的数据数组
                JSONArray dataArray = mMetaInfo.getJSONArray(GTaskStringUtils.META_HEAD_DATA);

                // 遍历数据数组
                for (int i = 0; i < dataArray.length(); i++) {
                    // 获取数组中的每一个数据对象
                    JSONObject data = dataArray.getJSONObject(i);
                    // 如果数据对象的MIME类型为笔记
                    if (TextUtils.equals(data.getString(DataColumns.MIME_TYPE), DataConstants.NOTE)) {
                        // 将数据对象的content字段设置为getName()方法的返回值
                        data.put(DataColumns.CONTENT, getName());
                        // 跳出循环
                        break;
                    }
                }

                // 将note的type设置为Notes.TYPE_NOTE
                note.put(NoteColumns.TYPE, Notes.TYPE_NOTE);
                // 返回mMetaInfo
                return mMetaInfo;
            }
        } catch (JSONException e) {
            // 打印错误日志
            Log.e(TAG, e.toString());
            // 打印错误堆栈
            e.printStackTrace();
            // 返回null
            return null;
        }
    }

    public void setMetaInfo(MetaData metaData) {
        // 判断传入的metaData是否为空，并且metaData中的notes是否为空
        if (metaData != null && metaData.getNotes() != null) {
            try {
                // 将metaData中的notes转换为JSONObject
                mMetaInfo = new JSONObject(metaData.getNotes());
            } catch (JSONException e) {
                // 如果转换失败，打印错误日志，并将mMetaInfo置为null
                Log.w(TAG, e.toString());
                mMetaInfo = null;
            }
        }
    }

 // 根据游标c获取同步动作
    public int getSyncAction(Cursor c) {
        try {
            // 获取noteInfo对象
            JSONObject noteInfo = null;
            if (mMetaInfo != null && mMetaInfo.has(GTaskStringUtils.META_HEAD_NOTE)) {
                noteInfo = mMetaInfo.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);
            }

            // 如果noteInfo为空，则说明note meta已经被删除
            if (noteInfo == null) {
                Log.w(TAG, "it seems that note meta has been deleted");
                return SYNC_ACTION_UPDATE_REMOTE;
            }

            // 如果noteInfo中没有ID，则说明remote note id已经被删除
            if (!noteInfo.has(NoteColumns.ID)) {
                Log.w(TAG, "remote note id seems to be deleted");
                return SYNC_ACTION_UPDATE_LOCAL;
            }

            
            // 检查note id是否匹配
            if (c.getLong(SqlNote.ID_COLUMN) != noteInfo.getLong(NoteColumns.ID)) {
                Log.w(TAG, "note id doesn't match");
                return SYNC_ACTION_UPDATE_LOCAL;
            }

            // 检查本地是否修改
            if (c.getInt(SqlNote.LOCAL_MODIFIED_COLUMN) == 0) {
                
                // 检查同步id是否匹配
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                   
                    return SYNC_ACTION_NONE;
                } else {
                    
                    return SYNC_ACTION_UPDATE_LOCAL;
                }
            } else {
                
                // 检查gtask id是否匹配
                if (!c.getString(SqlNote.GTASK_ID_COLUMN).equals(getGid())) {
                    Log.e(TAG, "gtask id doesn't match");
                    return SYNC_ACTION_ERROR;
                }
                // 检查同步id是否匹配
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                    
                    return SYNC_ACTION_UPDATE_REMOTE;
                } else {
                    return SYNC_ACTION_UPDATE_CONFLICT;
                }
            }
        } catch (Exception e) {
            // 打印错误日志
            Log.e(TAG, e.toString());
            // 打印堆栈信息
            e.printStackTrace();
        }

        return SYNC_ACTION_ERROR;
    }

    public boolean isWorthSaving() {
        // 判断是否需要保存，如果mMetaInfo不为空，或者getName()不为空且长度大于0，或者getNotes()不为空且长度大于0，则返回true
        return mMetaInfo != null || (getName() != null && getName().trim().length() > 0)
                || (getNotes() != null && getNotes().trim().length() > 0);
    }

    public void setCompleted(boolean completed) {
        // 设置任务是否完成
        this.mCompleted = completed;
    }

    public void setNotes(String notes) {
        // 设置任务备注
        this.mNotes = notes;
    }

    public void setPriorSibling(Task priorSibling) {
        // 设置任务的前一个兄弟任务
        this.mPriorSibling = priorSibling;
    }

    public void setParent(TaskList parent) {
        // 设置任务的父任务列表
        this.mParent = parent;
    }

    public boolean getCompleted() {
        // 返回任务是否完成
        return this.mCompleted;
    }

    public String getNotes() {
        // 返回任务的备注
        return this.mNotes;
    }

    public Task getPriorSibling() {
        // 返回任务的前一个兄弟任务
        return this.mPriorSibling;
    }

    public TaskList getParent() {
        // 返回任务的父任务列表
        return this.mParent;
    }

}
